import java.io.*;
import java.sql.*;
import java.net.*;
import com.csvreader.CsvReader;
/**
 * Write a description of class ArtCollector here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class ArtCollector
{
    // instance variables - replace the example below with your own
    String driver = "com.mysql.jdbc.Driver";
    String jdbc = "jdbc:mysql:";    
    String database = "ArtCollection";
    String account = "root";
    String password = "";    
    String url = "//localhost:3306/" + database;
    String query;
    Connection conn;
    ResultSet rs;
    PreparedStatement stmt;

    private CsvReader input;
    private URL csvurl;
    private URLConnection in;
    private int artistPK;
    private int artPK;
    private Art art;
    private Painting painting;
    private Sculpture sculpture;

    /**
     * Constructor for objects of class ArtCollector
     */
    public ArtCollector()
    {

    }

    public Connection getConnection()
    {
        try {
            conn = DriverManager.getConnection(jdbc + url, account, password);
        } catch (SQLException error) {
            System.out.println("Error connecting to database: "
                + error.toString());
            System.exit(2);
        }
        return conn;
    }

    /**
     * Process input CSV file 
     */
    public void addRecords()
    {
        try {
            csvurl = new URL("http://people.terry.uga.edu/rwatson/data/art.csv"); // get the URL
            URLConnection in = csvurl.openConnection();
        } catch (IOException error) {
            System.out.println("Error accessing url: "
                + error.toString());
            System.exit(3);
        }
        conn = getConnection(); // connect to the database
        try {
            input = new CsvReader(new InputStreamReader(csvurl.openStream()));
            input.readHeaders();
            while (input.readRecord())
            {
                // Artist
                String firstName  = input.get("firstName");
                String lastName = input.get("lastName");
                String nationality = input.get("nationality");
                int birthYear = Integer.parseInt(input.get("birthyear"));
                int deathYear = Integer.parseInt(input.get("deathyear"));
                artistPK = addArtist(conn, firstName, lastName, nationality, birthYear, deathYear);
                // Art
                String title = input.get("title");
                double length = Double.parseDouble(input.get("length"));
                double breadth = Double.parseDouble(input.get("breadth"));
                int year = Integer.parseInt(input.get("year"));
                art = new Art();
                artPK = art.addArt(conn, title, length, breadth, year,artistPK);

                String type = input.get("type");
                if (type.equals("Painting")) {
                    String style = input.get("style");
                    String medium = input.get("medium");
                    painting = new Painting();
                    painting.addPainting(conn, style, medium, artPK);
                }
                if (type.equals("Sculpture")) {
                    double height = Double.parseDouble(input.get("height"));
                    String material = input.get("material");
                    sculpture = new Sculpture();
                    sculpture.addSculpture(conn, height, material, artPK);
                }
            }
            input.close();
        } catch (IOException error) {
            System.out.println("Error reading CSV file: "
                + error.toString());
            System.exit(4);
        }
    }

    /**
     * Add artist
     */
    public int addArtist(Connection conn, String firstName, String lastName, String nationality, int birthYear,int deathYear)
    {
        int autoIncKey = 0;
        try {
            stmt = conn.prepareStatement("INSERT INTO artist (firstName, lastName, birthyear, deathyear, nationality) VALUES ( ?, ?, ?, ?, ?)");
            stmt.setString(1,firstName);
            stmt.setString(2,lastName);
            stmt.setInt(3,birthYear);
            stmt.setInt(4,deathYear);
            stmt.setString(5,nationality);
            stmt.executeUpdate();
            System.out.println(stmt);
            // get the autoincremented identifier to use as a foreign key
            rs = stmt.executeQuery("SELECT LAST_INSERT_ID()");
            if (rs.next()) {
                autoIncKey = rs.getInt(1);
            } else {
                // throw an exception from here
            }
            rs.close();
        }
        catch (SQLException error)
        {
            System.out.println("Error inserting into database: "
                + error.toString());
            System.exit(5);
        }
        return autoIncKey;
    }

    public int getNumberOfSculptures()
    {
        getConnection();
        int count = 0;
        try {
            stmt = conn.prepareStatement("SELECT COUNT(*) FROM sculpture");
            rs = stmt.executeQuery();

            while (rs.next()) 
            {
                count = rs.getInt(1);
            } 

        }
        catch (SQLException error)
        {
            System.out.println("Error reporting from database when getting count: " + error.toString());
            System.exit(2);
        }

        return count;

    }
}

